# 米斯特白帽培训讲义 漏洞篇 逻辑漏洞

> 讲师：[gh0stkey](https://www.zhihu.com/people/gh0stkey/answers)

> 整理：[飞龙](https://github.com/)

> 协议：[CC BY-NC-SA 4.0](http://creativecommons.org/licenses/by-nc-sa/4.0/)

## 任意密码找回

这是补天平台上的一个案例：

http://www.118114.cn/reg.jsp

首先注册一个账号，然后找回。

![](http://ww1.sinaimg.cn/large/841aea59jw1fb42autmgpj20dw05pq2v.jpg)

我们收到的验证码是六位数。如果网站没有设置频率限制，或者最大尝试次数限制的话，那我们自然就会想到可以爆破它。

![](http://ww3.sinaimg.cn/large/841aea59jw1fb42axj9tuj20ff0mc0t4.jpg)

然后抓提交手机验证码的封包，我们可以看到没有任何图片验证码：

![](http://ww2.sinaimg.cn/large/841aea59jw1fb42b0pjpzj20nf08iaam.jpg)

发送到 Burp 的 Intruder：

![](http://ww2.sinaimg.cn/large/841aea59jw1fb42b7hh53j20ed09p74h.jpg)

只给`checkPhoneCode`添加标志，然后将字典类型设置为数字，范围为`000000 ~ 999999`。然后爆破，结束后我们发现了一个与众不同的封包。

![](http://ww3.sinaimg.cn/large/841aea59jw1fb42ijvea1j208q04vgli.jpg)

将里面的验证码提交之后便可重置密码。

![](http://ww1.sinaimg.cn/large/841aea59jw1fb42ba6wpgj20ng0cumxf.jpg)

## 任意手机号注册

这是某个网站的注册页面：

![](http://ww1.sinaimg.cn/large/841aea59jw1fb42bozb1lj20fz0draa4.jpg)

我们模拟注册一下，发现手机验证码是四位：

![](http://ww3.sinaimg.cn/large/841aea59jw1fb42ccsbb7j20g904ljrc.jpg)


然后抓注册的封包：

![](http://ww3.sinaimg.cn/large/841aea59jw1fb42c0v90yj20nc05emxc.jpg)

然后将字典设置为四位数字 0000 ~ 9999，进行爆破：

![](http://ww2.sinaimg.cn/large/841aea59jw1fb42buvzlvj20il07nweq.jpg)

Get it！

## 任意邮箱激活

目标是`www.vobao.com`。

首先注册，然后直接退出找回，我们看到它是邮箱验证。

![](http://ww2.sinaimg.cn/large/841aea59jw1fb42cmphhuj20n50dx750.jpg)

然后查看验证邮件：

![](http://ww3.sinaimg.cn/large/841aea59jw1fb42crq27lj20nc066jrr.jpg)

我们发现其中有一个`vstr`，它跟找回密码页面中的某个 URL 是一样的，也就是一个标志。

![](http://ww2.sinaimg.cn/large/841aea59jw1fb42d74r87j20nj02i749.jpg)

那么`vud`就应该起到类似验证码的作用。如果我们不填写`vud`直接访问，显示无效。那么就能确定它是验证码了。

![](http://ww4.sinaimg.cn/large/841aea59jw1fb42dv96oyj20jo0aqaad.jpg)

这个`vud`看起来像是个md5，但是实际上是随机码。那么我们尝试拿另一个邮箱注册找回：

![](http://ww3.sinaimg.cn/large/841aea59jw1fb42eeqqvwj20n7032jrg.jpg)

可以看到`vstr`是不一样的，`vud`当然也不一样。但是如果我们邮箱2的`vud`拼接到邮箱1的`vstr`上呢？由于邮箱1的`vstr`是已知的，即使我们访问不了邮箱1，也可以通过找回密码页面的 URL 来获得，那么我们就可以构造出：

![](http://ww3.sinaimg.cn/large/841aea59jw1fb42g1d0o4j20jm02t74b.jpg)

提交后就成功了。

![](http://ww4.sinaimg.cn/large/841aea59jw1fb42g3wxn9j20nf0axq3j.jpg)

假设邮箱1是别人的邮箱，我们不能访问其内容，但我们能够控制邮箱2，那我们就能拿邮箱2来重置邮箱1的账户。可以看到，这个漏洞的主要成因就是未对不同用户的验证码进行区分。其中`vstr`起到用户标志的作用，`vud`起到邮箱验证码的作用。
